package com.outbrain.catalog.GridLayouts;

import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;

import com.outbrain.OBSDK.Entities.OBRecommendation;
import com.outbrain.OBSDK.Entities.OBRecommendationsResponse;
import com.outbrain.OBSDK.FetchRecommendations.OBRequest;
import com.outbrain.OBSDK.FetchRecommendations.RecommendationsListener;
import com.outbrain.OBSDK.Outbrain;
import com.outbrain.catalog.R;
import com.outbrain.catalog.Utils.CatalogUtils;
import com.outbrain.catalog.Utils.GridView.AutoMeasureGridView;
import com.outbrain.catalog.Utils.GridView.GridAdapter;


public class GridWithImagesActivity extends AppCompatActivity implements RecommendationsListener {
    private AutoMeasureGridView gridView;

    @Override
    public void onCreate(Bundle savedBundle) {
        super.onCreate(savedBundle);
        setContentView(R.layout.outbrain_grid_images_activity);

        gridView = findViewById(R.id.outbrain_grid_layouts_grid_view);
        fetchRecommendations();
    }

    private void fetchRecommendations() {
        OBRequest request = new OBRequest();
        request.setWidgetId("SDK_4");
        request.setUrl(getString(R.string.outbrain_sample_url));
        Outbrain.fetchRecommendations(request, this);
    }

    @Override
    public void onOutbrainRecommendationsSuccess(final OBRecommendationsResponse recommendations) {
        populateGridView(recommendations);
    }

    @Override
    public void onOutbrainRecommendationsFailure(Exception ex) {
        ex.printStackTrace();
    }

    private void populateGridView(final OBRecommendationsResponse recommendations) {
        GridAdapter adapter = new GridAdapter(this, R.layout.grid_with_image, recommendations.getAll());
        gridView.setAdapter(adapter);
        gridView.setOnItemClickListener((adapterView, view, i, l) -> openRecommendationInBrowser(recommendations.get(i)));
    }

    private void openRecommendationInBrowser(OBRecommendation obRecommendation) {
        CatalogUtils.openURLInBrowser(Outbrain.getUrl(obRecommendation), this);
    }
}


